/*
 * This file is part of uudeview, the simple and friendly multi-part multi-
 * file uudecoder  program  (c)  1994 by Frank Pilhofer. The author may be
 * contacted by his email address,          fp@informatik.uni-frankfurt.de
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 */



/*
 * tar data structure
 **/

#define TARBLOCK	512
#define TARNAMSIZ	100

typedef union {
  char dummy[TARBLOCK];

  struct {
    char name[TARNAMSIZ];
    char mode[8];
    char uid[8];
    char gid[8];
    char size[12];
    char mtime[12];
    char chksum[8];
    char linkflag;
    char linkname[TARNAMSIZ];
    char extno[4];
    char extotal[4];
    char efsize[12];
  } header;
} tarblock;

long		getokt		(char *);
int		istarfile	(uulist *);
uulist *	tar2bin 	(uulist *);
uulist *	tarscan		(uulist *);
